diff -r 411de35de7fc -r 78219b10be7c libinterp/corefcn/stack-frame.cc
--- a/libinterp/corefcn/stack-frame.cc	Mon Jan 22 11:27:42 2024 +0100
+++ b/libinterp/corefcn/stack-frame.cc	Mon Jan 22 23:38:08 2024 +0100
@@ -1271,243 +943,154 @@
 
         if (local_offset >= internal_size ())
           internal_resize (local_offset + 1);
-
-        internal_set_extra_name (local_offset, sym.name ());
       }
 
     return sym;
   }
 
-  symbol_scope get_scope () const
-  {
-    return m_fcn->scope ();
-  }
-
-  octave_function * function () const { return m_fcn; }
-
   void accept (stack_frame_walker& sfw);
 
   void display (bool follow = true) const;
-
-  int line () const
-  {
-    if (! m_vm)
-      return -1;
-
-    loc_entry loc = vm::find_loc (m_ip, m_unwind_data->m_loc_entry); // TODO: Does not work in nested bytecode stack frames
-    return loc.m_line;
-  }
-
-  int column () const
+};
+
+
+// Class for bytecode scripts
+//
+// Much of the functionaility is delegated to the eval frame
+// (.i.e top repl frame or calling function frame).
+
+class bytecode_script_stack_frame : public bytecode_frame
+{
+public:
+
+  bytecode_script_stack_frame () = delete;
+
+  bytecode_script_stack_frame (tree_evaluator& tw,
+                               octave_user_code *fcn,
+                               std::size_t index,
+                               const std::shared_ptr<stack_frame>& parent_link,
+                               const std::shared_ptr<stack_frame>& static_link,
+                               vm &vm,
+                               int nargout, int nargin)
+    : bytecode_frame (tw, index, parent_link, static_link,
+                   nullptr, vm, fcn, nargout, nargin)
   {
-    if (! m_vm)
-      return -1;
-
-    loc_entry loc = vm::find_loc (m_ip, m_unwind_data->m_loc_entry);
-    return loc.m_col;
+    CHECK_PANIC (fcn->is_user_script () && !fcn->is_nested_function());
   }
 
-  unwind_protect *unwind_protect_frame ()
+  bytecode_script_stack_frame&
+  operator = (const bytecode_script_stack_frame& elt) = delete;
+
+  bytecode_script_stack_frame&
+  operator = (bytecode_script_stack_frame&& elt) = delete;
+
+  ~bytecode_script_stack_frame ()
   {
-    if (! lazy_data ().m_unwind_protect_frame)
-      lazy_data ().m_unwind_protect_frame = new unwind_protect ();
-
-    return lazy_data ().m_unwind_protect_frame;
+    // vm_clear_for_cache () need to mirror the dtor
+    dispose ();
+  }
+
+  stack_frame::scope_flags scope_flag (const symbol_record& sym) const
+  {
+    // Delegate to problem to the eval frame
+    auto sym_in_root = access_link ()->lookup_symbol (sym.name ());
+    if (!sym_in_root)
+      return LOCAL; // Not found, return nil
+
+    return access_link ()->scope_flag (sym_in_root);
   }
 
-  std::weak_ptr<stack_frame> m_weak_ptr_to_self;
-
-  void vm_enter_nested ()
+  // We only need to override one of each of these functions.  The
+  // using declaration will avoid warnings about partially-overloaded
+  // virtual functions.
+  using stack_frame::varval;
+  using stack_frame::varref;
+
+  octave_value varval (const symbol_record& sym) const
+  {
+    // Delegate to problem to the eval frame
+    auto sym_in_root = access_link ()->lookup_symbol (sym.name ());
+    if (!sym_in_root)
+      return {}; // Not found, return nil
+
+    return access_link ()->varval (sym_in_root);
+  }
+
+  octave_value& varref (const symbol_record& sym, bool deref_refs)
   {
-    // We got multiple scenarios.
-    //
-    // 1. The parents are bytecode functions in the order
-    //    according to the nesting of nested functions. This should be the
-    //    most common use. Self-recursive calls are handled too.
-    //
-    // 2. If a nested function calls a sibling nested function, the parent frames
-    //    which are not direct parents to the nested sibling funtion need to be skipped
-    //    while searching for the matriarch frame.
-    //
-    // 3. A nested function is called via a handle.
-
-    bool is_direct_call = true;
-
-    auto parent_frame = static_link ();
-
-    auto *child_bc_frame = this;
-
-    // Walk the parent(s) to see if they are in direct order and all bytecode frames.
-    // Collect the bsp. (base stack pointer).
-
-    // TODO: There might be a need to check that all children share access frame?
-    int n_nested_depth = m_unwind_data->m_n_nested_fn;
-    std::vector<stack_element*> v_parent_bsps;
-    int i;
-    for (i = 0; i < n_nested_depth; i++)
+    // Delegate to problem to the eval frame
+    auto sym_in_root = access_link ()->insert_symbol (sym.name ());
+    CHECK_PANIC (sym_in_root.frame_offset () == 0);
+
+    return access_link ()->varref (sym_in_root, deref_refs);
+  }
+
+  void mark_scope (const symbol_record& sym,
+                   scope_flags flag)
+  {
+    // Delegate to problem to the eval frame
+    auto sym_in_root = access_link ()->insert_symbol (sym.name ());
+    CHECK_PANIC (sym_in_root.frame_offset () == 0);
+
+    // TODO: script_stack_frame seems to error if frame offset is non-zero ->
+    //   if (frame_offset > 1)
+    //     error ("variables must be made PERSISTENT or GLOBAL in the first scope in which they are used");
+
+    return access_link ()->mark_scope (sym_in_root, flag);
+  }
+
+  bool is_user_script_frame () const { return true; }
+
+  symbol_record lookup_symbol (const std::string& name) const
+  {
+    symbol_scope scope = get_scope ();
+
+    symbol_record sym = scope.lookup_symbol (name);
+
+    if (sym)
       {
-        bool collect_frame_bsp = true;
-        bool forward_child_ptr = true;
-
-        if (!parent_frame->is_bytecode_fcn_frame ())
-          {
-            is_direct_call = false;
-            break;
-          }
-
-        auto *parent_bc_frame = static_cast<bytecode_fcn_stack_frame*> (parent_frame.get ());
-
-        // Recursive self call?
-        if (parent_bc_frame->m_unwind_data->m_id == child_bc_frame->m_unwind_data->m_id)
-          {
-            collect_frame_bsp = false;
-            i--;
-          }
-        // Not direct parent?
-        else if (parent_bc_frame->m_unwind_data->m_id != child_bc_frame->m_unwind_data->m_parent_id)
-          {
-            // Sibling or their children?
-            if (parent_bc_frame->m_unwind_data->m_matriarch_id == child_bc_frame->m_unwind_data->m_matriarch_id)
-              {
-                collect_frame_bsp = false;
-                forward_child_ptr = false; // Keep looking for the parent of the current child ptr
-                i--;
-              }
-            else
-              {
-                // At the last depth the access frame might be the final parent.
-                if (i + 1 != n_nested_depth)
-                  {
-                    is_direct_call = false;
-                    break;
-                  }
-
-                auto access_frame = access_link ();
-
-                if (!access_frame || !access_frame->is_bytecode_fcn_frame ())
-                  {
-                    is_direct_call = false;
-                    break;
-                  }
-
-                auto access_bc_frame = static_cast<bytecode_fcn_stack_frame*> (access_frame.get ());
-                // Check that the access frame the matriarch of the current frame.
-                if (access_bc_frame->m_unwind_data->m_id != m_unwind_data->m_matriarch_id)
-                  {
-                    is_direct_call = false;
-                    break;
-                  }
-
-                // The access frame is the last parent
-                parent_bc_frame = access_bc_frame;
-              }
-          }
-
-        // We don't collect recursive self-calls' or siblings' or siblings' childrens' frames
-        if (collect_frame_bsp)
-          v_parent_bsps.push_back (parent_bc_frame->m_stack_start);
-
-        // Skip copying the shared pointer if we don't need it as there is no next iteration
-        // since shared_ptr:s are quite expensive to use.
-        if (i + 1 == n_nested_depth)
-          break;
-
-        parent_frame = parent_frame->static_link ();
-        if (forward_child_ptr)
-          child_bc_frame = parent_bc_frame;
-        parent_bc_frame = static_cast<bytecode_fcn_stack_frame*> (parent_frame.get ());
+        CHECK_PANIC (sym.frame_offset () == 0);
+        return sym;
       }
 
-    if (is_direct_call)
+    // Lookup in the eval frame
+    sym = m_access_link->lookup_symbol (name);
+
+    // Return symbol record with adjusted frame offset.
+    symbol_record new_sym = sym.dup ();
+
+    new_sym.set_frame_offset (sym.frame_offset () + 1);
+
+    return new_sym;
+  }
+
+  symbol_record insert_symbol (const std::string& name)
+  {
+    symbol_scope scope = get_scope ();
+
+    symbol_record sym = scope.lookup_symbol (name);
+
+    if (sym)
       {
-        for (unwind_data::nested_var_offset &d : m_unwind_data->m_v_nested_vars)
-        {
-          int parent_slot = d.m_slot_parent;
-          int nested_slot = d.m_slot_nested;
-          int depth = d.m_depth;
-
-          stack_element *owner_bsp = v_parent_bsps.at (depth - 1);
-
-          octave_value &orig_ov = owner_bsp[parent_slot].ov; // On the parent stack
-          octave_value &nested_ov = m_stack_start[nested_slot].ov; // On the current stack
-
-          // If the ov on the parent stack is a pointer reference we need to follow it.
-          if (orig_ov.is_ref ())
-            {
-              auto ref_rep = orig_ov.ref_rep ();
-              if (ref_rep->is_ptr_ref ())
-                orig_ov = ref_rep->ref ();
-            }
-
-          CHECK_PANIC (&orig_ov != &nested_ov);
-
-          // Make the nested ov reference the ov on the parent stack.
-          nested_ov = new octave_value_ref_ptr (&orig_ov);
-        }
+        CHECK_PANIC(sym.frame_offset () == 0);
+        return sym;
       }
-    else
-      {
-        // For a nested function at nesting depth n we need to collect n
-        // access links.
-        auto first_context_frame = access_link ();
-        CHECK_PANIC (first_context_frame);
-
-        std::vector<decltype(first_context_frame)> v_frames {std::move (first_context_frame)};
-
-        // TODO: Need to make test cases to verify that this works for nested nested function handles from
-        //       used in other function than the original root function.
-        for (int j = 1; j < m_unwind_data->m_n_nested_fn; j++) // 1, since first one already added
-          {
-            auto &upper_frame = v_frames.back ();
-            auto lower_frame = upper_frame->access_link ();
-
-            CHECK_PANIC (lower_frame);
-            v_frames.push_back (lower_frame);
-          }
-
-        // For each variable that refer to variables on the parent frames, we need to link
-        // the local variable of the current frame to the correct slot on the parents'.
-        for (unwind_data::nested_var_offset &d : m_unwind_data->m_v_nested_vars)
-          {
-            int parent_slot = d.m_slot_parent;
-            int nested_slot = d.m_slot_nested;
-            int depth = d.m_depth;
-
-            octave_value &nested_ov = m_stack_start[nested_slot].ov; // On the current stack
-
-            auto &context_frame = v_frames.at (depth - 1);
-            auto context_scope = context_frame->get_scope ();
-
-            auto sym = context_scope.find_symbol (m_name_data [nested_slot]);
-            CHECK_PANIC (sym.is_valid ());
-
-            // For bytecode frames we just do a pointer octave_value object refering to
-            // to address in memory. For other frames we need to access it via the dynamic frame pointer
-            // (since the memory in those can move around)
-            if (context_frame->is_bytecode_fcn_frame ())
-              {
-                auto *context_bc_frame = static_cast<bytecode_fcn_stack_frame*> (context_frame.get ());
-                auto owner_bsp = context_bc_frame->m_stack_start;
-                octave_value &orig_ov = owner_bsp[parent_slot].ov; // On the parent stack
-
-                // If the ov on the parent stack is a pointer reference we need to follow it.
-                if (orig_ov.is_ref ())
-                  {
-                    auto ref_rep = orig_ov.ref_rep ();
-                    if (ref_rep->is_ptr_ref ())
-                      orig_ov = ref_rep->ref ();
-                  }
-
-                CHECK_PANIC (&orig_ov != &nested_ov);
-
-                nested_ov = new octave_value_ref_ptr (&orig_ov); // Pointer object octave_value_ref_ptr to parent stack
-              }
-            else
-              nested_ov = new octave_value_ref_vmlocal (sym, context_frame.get ());
-          }
-      }
+
+    // Insert the symbol in the eval frame
+    sym = m_access_link->insert_symbol (name);
+
+    // Return symbol record with adjusted frame offset.
+    symbol_record new_sym = sym.dup ();
+
+    new_sym.set_frame_offset (sym.frame_offset () + 1);
+
+    return new_sym;
   }
 
+  void accept (stack_frame_walker& sfw);
+
+  void display (bool follow = true) const;
+
   void vm_enter_script ()
   {
     CHECK_PANIC (m_fcn->is_user_script ());
@@ -1705,60 +1288,6 @@
       }
   }
 
-  void break_closure_cycles (const std::shared_ptr<stack_frame> &frame)
-  {
-    if (m_stack_start)
-      {
-        for (unsigned i = 1; i < m_size; i++)
-          {
-            // break_closure_cycles () is making a clone of nil values
-            // but we want nil values to have the same m_rep pointer, on the
-            // VM stack. is_nil () wont return true on a cloned nil value.
-            if (!m_stack_start[i].ov.is_nil ())
-              m_stack_start[i].ov.break_closure_cycles (frame);
-          }
-      }
-
-    if (m_lazy_data)
-      {
-        for (octave_value &ov : m_lazy_data->m_extra_slots)
-          {
-            if (!ov.is_nil ())
-              ov.break_closure_cycles (frame);
-          }
-      }
-
-    if (m_access_link)
-      m_access_link->break_closure_cycles (frame);
-  }
-
-  // To keep down the footprint of the frame some seldom used
-  // variables are lazy initialized and stored in *m_lazy_data
-  struct lazy_data_struct
-  {
-    octave_value m_ignored;
-    octave_value m_arg_names;
-    octave_value m_saved_warnings_states;
-
-    std::vector<octave_value> m_extra_slots;
-    std::vector<std::string> m_extra_names;
-
-    unwind_protect *m_unwind_protect_frame = nullptr;
-    stack_element *m_stack_cpy = nullptr;
-    bool m_is_script;
-  };
-
-  lazy_data_struct & lazy_data ()
-  {
-    if (!m_lazy_data)
-      m_lazy_data = new lazy_data_struct {};
-    return *m_lazy_data;
-  }
-
-  bool is_script_frame () { return m_unwind_data->m_is_script; }
-
-  lazy_data_struct *m_lazy_data = nullptr;
-
 private:
 
   // Returns true of the stack frames under this frame are in order, i.e.
@@ -1779,24 +1308,456 @@
 
     return true;
   }
-
-  octave_user_code *m_fcn;
-
-  unwind_data *m_unwind_data;
-
-  std::string *m_name_data;
-  stack_element *m_stack_start;
-
-  unsigned char *m_code;
-  unsigned m_size;
-  unsigned m_orig_size;
-  vm *m_vm;
-  int m_ip;
-
-  int m_nargin;
-  int m_nargout;
 };
 
+class bytecode_nested_fcn_stack_frame : public bytecode_frame
+{
+public:
+
+  bytecode_nested_fcn_stack_frame () = delete;
+
+  bytecode_nested_fcn_stack_frame (tree_evaluator& tw,
+                                   octave_user_code *fcn,
+                                   std::size_t index,
+                                   const std::shared_ptr<stack_frame>& parent_link,
+                                   const std::shared_ptr<stack_frame>& static_link,
+                                   const std::shared_ptr<stack_frame>& access_link,
+                                   vm &vm,
+                                   int nargout, int nargin)
+    : bytecode_frame (tw, index, parent_link, static_link,
+                      // If a access_link is provided, we are dealing with a closure from a function handle.
+                      // Otherwise find the access frame with get_access_link()
+                      access_link ? access_link : get_access_link (static_cast<octave_user_function*> (fcn), static_link),
+                    vm, fcn, nargout, nargin)
+  { }
+
+  ~bytecode_nested_fcn_stack_frame ()
+  {
+    // vm_clear_for_cache () need to mirror the dtor
+    dispose ();
+  }
+
+  static std::shared_ptr<stack_frame>
+  get_access_link (octave_user_function *fcn,
+                   const std::shared_ptr<stack_frame>& static_link)
+  {
+    std::shared_ptr<stack_frame> alink;
+
+    symbol_scope fcn_scope = fcn->scope ();
+
+    CHECK_PANIC(fcn_scope.is_nested ());
+
+    if (! static_link)
+      error ("internal call stack error (invalid static link)");
+
+    symbol_scope caller_scope = static_link->get_scope ();
+
+    int nesting_depth = fcn_scope.nesting_depth ();
+    int caller_nesting_depth = caller_scope.nesting_depth ();
+
+    if (caller_nesting_depth < nesting_depth)
+      {
+        // FIXME: do we need to ensure that the called
+        // function is a child of the caller?  Does it hurt
+        // to panic_unless this condition, at least for now?
+
+        alink = static_link;
+      }
+    else
+      {
+        // FIXME: do we need to check that the parent of the
+        // called function is also a parent of the caller?
+        // Does it hurt to panic_unless this condition, at least
+        // for now?
+
+        int links_to_follow = caller_nesting_depth - nesting_depth + 1;
+
+        alink = static_link;
+
+        while (alink && --links_to_follow >= 0)
+          alink = alink->access_link ();
+
+        if (! alink)
+          error ("internal function nesting error (invalid access link)");
+      }
+
+    return alink;
+  }
+
+  void resize (std::size_t arg)
+  {
+    int diff = static_cast<int> (arg) - static_cast<int> (size ());
+
+    if (diff > 0)
+      internal_resize (internal_size () + diff);
+  }
+
+  stack_frame::scope_flags scope_flag (const symbol_record& sym) const
+  {
+    std::size_t external_offset = sym.data_offset ();
+    std::size_t frame_offset = sym.frame_offset ();
+
+    std::size_t internal_offset;
+
+    // Note, quirk: A variable that is not added to a nested frame is not to be reported as global
+    // eventhough it is global in the parent frame.
+
+    if (frame_offset)
+      {
+        auto it = m_unwind_data->m_external_frame_offset_to_internal.at (frame_offset).find (external_offset);
+        bool found = it != m_unwind_data->m_external_frame_offset_to_internal[frame_offset].end ();
+        if (!found)
+          return LOCAL;
+
+        internal_offset = it->second;
+      }
+    else
+      internal_offset = external_to_local_offset (external_offset);
+
+    return get_scope_flag_internal (internal_offset);
+  }
+
+  // We only need to override one of each of these functions.  The
+  // using declaration will avoid warnings about partially-overloaded
+  // virtual functions.
+  using stack_frame::varval;
+  using stack_frame::varref;
+
+  octave_value varval (const symbol_record& sym) const
+  {
+    std::size_t external_offset = sym.data_offset ();
+    std::size_t frame_offset = sym.frame_offset ();
+
+    if (frame_offset >= n_compiled_frame_depth ())
+      return {};
+
+    if (frame_offset)
+      {
+        auto access_frame = get_ith_access_link (frame_offset - 1);
+        CHECK_PANIC (access_frame);
+
+        return access_frame->varval (external_offset);
+      }
+
+    std::size_t internal_offset = external_to_local_offset (external_offset, frame_offset);
+
+    // If the offset is out of range we return a nil ov. A varref() call would add
+    // an extra slot.
+    if (internal_offset >= internal_size ())
+      return {};
+
+    return varval_internal (internal_offset);
+  }
+
+  octave_value& varref (const symbol_record& sym, bool deref_refs)
+  {
+    std::size_t external_offset = sym.data_offset ();
+    std::size_t frame_offset = sym.frame_offset ();
+
+    CHECK_PANIC (frame_offset < n_compiled_frame_depth ());
+
+    if (frame_offset)
+      {
+        auto access_frame = get_ith_access_link (frame_offset - 1);
+        CHECK_PANIC (access_frame);
+
+        return access_frame->varref (external_offset, deref_refs);
+      }
+
+    std::size_t local_offset = external_to_local_offset (external_offset, frame_offset);
+
+    // If the offset is out of range we make room for it
+    if (local_offset >= internal_size ())
+      internal_resize (local_offset + 1);
+
+    return varref_internal (local_offset, deref_refs);
+  }
+
+  void mark_scope (const symbol_record& sym,
+                   scope_flags flag)
+  {
+    std::size_t external_offset = sym.data_offset ();
+    std::size_t frame_offset = sym.frame_offset ();
+
+    if (frame_offset > 0 && (flag == PERSISTENT || flag == GLOBAL))
+      error ("variables must be made PERSISTENT or GLOBAL in the first scope in which they are used");
+    else if (frame_offset > 0)
+      return;
+
+    std::size_t local_offset = external_to_local_offset (external_offset, frame_offset);
+
+    if (local_offset >= internal_size ())
+      internal_resize (local_offset + 1);
+
+    set_scope_flag_internal (local_offset, external_offset, frame_offset, flag);
+  }
+
+  bool is_user_fcn_frame () const { return true; }
+
+  symbol_record lookup_symbol (const std::string& name) const
+  {
+    // Search the "scope" object of this and any nested frame
+    // The scope object will have e.g. variables added by scripts, global declares or eval
+    const stack_frame *frame = this;
+    std::size_t frame_cntr = 0;
+    while (frame)
+      {
+        symbol_scope scope = frame->get_scope ();
+
+        symbol_record sym = scope.lookup_symbol (name);
+
+        if (sym)
+          {
+            // Return symbol record with adjusted frame offset relative
+            // to the one lookup is done on, i.e. the 'this' frame.
+            symbol_record new_sym = sym.dup ();
+            new_sym.set_frame_offset (new_sym.frame_offset () + frame_cntr);
+            return new_sym;
+          }
+
+        std::shared_ptr<stack_frame> nxt = frame->access_link ();
+        frame = nxt.get ();
+        frame_cntr++;
+      }
+
+    return symbol_record ();
+  }
+
+  symbol_record insert_symbol (const std::string& name)
+  {
+    symbol_scope scope = get_scope ();
+
+    symbol_record sym = scope.lookup_symbol (name);
+
+    if (!sym)
+      {
+        // If we have not created the extra slots, now is the time
+        lazy_data ();
+
+        sym = scope.find_symbol (name);
+
+        CHECK_PANIC (sym.is_valid ());
+        CHECK_PANIC (sym.frame_offset () == 0);
+
+        unsigned local_offset = external_to_local_offset (sym.data_offset ());
+
+        if (local_offset >= internal_size ())
+          internal_resize (local_offset + 1);
+      }
+
+    return sym;
+  }
+
+  void accept (stack_frame_walker& sfw);
+
+  void display (bool follow = true) const;
+
+  void vm_enter_nested ()
+  {
+    // We got multiple scenarios.
+    //
+    // 1. The parents are bytecode functions in the order
+    //    according to the nesting of nested functions. This should be the
+    //    most common use. Self-recursive calls are handled too.
+    //
+    // 2. If a nested function calls a sibling nested function, the parent frames
+    //    which are not direct parents to the nested sibling funtion need to be skipped
+    //    while searching for the matriarch frame.
+    //
+    // 3. A nested function is called via a handle.
+
+    bool is_direct_call = true;
+
+    auto parent_frame = static_link ();
+
+    bytecode_frame *child_bc_frame = this;
+
+    // Walk the parent(s) to see if they are in direct order and all bytecode frames.
+    // Collect the bsp. (base stack pointer).
+
+    // TODO: There might be a need to check that all children share access frame?
+    int n_nested_depth = m_unwind_data->m_n_nested_fn;
+    std::vector<stack_element*> v_parent_bsps;
+    int i;
+    for (i = 0; i < n_nested_depth; i++)
+      {
+        bool collect_frame_bsp = true;
+        bool forward_child_ptr = true;
+
+        if (!parent_frame->is_bytecode_fcn_frame ())
+          {
+            is_direct_call = false;
+            break;
+          }
+
+        auto *parent_bc_frame = static_cast<bytecode_frame*> (parent_frame.get ());
+
+        // Recursive self call?
+        if (parent_bc_frame->m_unwind_data->m_id == child_bc_frame->m_unwind_data->m_id)
+          {
+            collect_frame_bsp = false;
+            i--;
+          }
+        // Not direct parent?
+        else if (parent_bc_frame->m_unwind_data->m_id != child_bc_frame->m_unwind_data->m_parent_id)
+          {
+            // Sibling or their children?
+            if (parent_bc_frame->m_unwind_data->m_matriarch_id == child_bc_frame->m_unwind_data->m_matriarch_id)
+              {
+                collect_frame_bsp = false;
+                forward_child_ptr = false; // Keep looking for the parent of the current child ptr
+                i--;
+              }
+            else
+              {
+                // At the last depth the access frame might be the final parent.
+                if (i + 1 != n_nested_depth)
+                  {
+                    is_direct_call = false;
+                    break;
+                  }
+
+                auto access_frame = access_link ();
+
+                if (!access_frame || !access_frame->is_bytecode_fcn_frame ())
+                  {
+                    is_direct_call = false;
+                    break;
+                  }
+
+                auto access_bc_frame = static_cast<bytecode_fcn_stack_frame*> (access_frame.get ());
+                // Check that the access frame the matriarch of the current frame.
+                if (access_bc_frame->m_unwind_data->m_id != m_unwind_data->m_matriarch_id)
+                  {
+                    is_direct_call = false;
+                    break;
+                  }
+
+                // The access frame is the last parent
+                parent_bc_frame = access_bc_frame;
+              }
+          }
+
+        // We don't collect recursive self-calls' or siblings' or siblings' childrens' frames
+        if (collect_frame_bsp)
+          v_parent_bsps.push_back (parent_bc_frame->m_stack_start);
+
+        // Skip copying the shared pointer if we don't need it as there is no next iteration
+        // since shared_ptr:s are quite expensive to use.
+        if (i + 1 == n_nested_depth)
+          break;
+
+        parent_frame = parent_frame->static_link ();
+        if (forward_child_ptr)
+          child_bc_frame = parent_bc_frame;
+      }
+
+    if (is_direct_call)
+      {
+        for (unwind_data::nested_var_offset &d : m_unwind_data->m_v_nested_vars)
+        {
+          int parent_slot = d.m_slot_parent;
+          int nested_slot = d.m_slot_nested;
+          int depth = d.m_depth;
+
+          stack_element *owner_bsp = v_parent_bsps.at (depth - 1);
+
+          octave_value &orig_ov = owner_bsp[parent_slot].ov; // On the parent stack
+          octave_value &nested_ov = m_stack_start[nested_slot].ov; // On the current stack
+
+          // If the ov on the parent stack is a pointer reference we need to follow it.
+          if (orig_ov.is_ref ())
+            {
+              auto ref_rep = orig_ov.ref_rep ();
+              if (ref_rep->is_ptr_ref ())
+                orig_ov = ref_rep->ref ();
+            }
+
+          CHECK_PANIC (&orig_ov != &nested_ov);
+
+          // Make the nested ov reference the ov on the parent stack.
+          nested_ov = new octave_value_ref_ptr (&orig_ov);
+        }
+      }
+    else
+      {
+        // For a nested function at nesting depth n we need to collect n
+        // access links.
+        auto first_context_frame = access_link ();
+        CHECK_PANIC (first_context_frame);
+
+        std::vector<decltype(first_context_frame)> v_frames {std::move (first_context_frame)};
+
+        // TODO: Need to make test cases to verify that this works for nested nested function handles from
+        //       used in other function than the original root function.
+        for (int j = 1; j < m_unwind_data->m_n_nested_fn; j++) // 1, since first one already added
+          {
+            auto &upper_frame = v_frames.back ();
+            auto lower_frame = upper_frame->access_link ();
+
+            CHECK_PANIC (lower_frame);
+            v_frames.push_back (lower_frame);
+          }
+
+        // For each variable that refer to variables on the parent frames, we need to link
+        // the local variable of the current frame to the correct slot on the parents'.
+        for (unwind_data::nested_var_offset &d : m_unwind_data->m_v_nested_vars)
+          {
+            int parent_slot = d.m_slot_parent;
+            int nested_slot = d.m_slot_nested;
+            int depth = d.m_depth;
+
+            octave_value &nested_ov = m_stack_start[nested_slot].ov; // On the current stack
+
+            auto &context_frame = v_frames.at (depth - 1);
+            auto context_scope = context_frame->get_scope ();
+
+            auto sym = context_scope.find_symbol (m_name_data [nested_slot]);
+            CHECK_PANIC (sym.is_valid ());
+
+            // For bytecode frames we just do a pointer octave_value object refering to
+            // to address in memory. For other frames we need to access it via the dynamic frame pointer
+            // (since the memory in those can move around)
+            if (context_frame->is_bytecode_fcn_frame ())
+              {
+                auto *context_bc_frame = static_cast<bytecode_fcn_stack_frame*> (context_frame.get ());
+                auto owner_bsp = context_bc_frame->m_stack_start;
+                octave_value &orig_ov = owner_bsp[parent_slot].ov; // On the parent stack
+
+                // If the ov on the parent stack is a pointer reference we need to follow it.
+                if (orig_ov.is_ref ())
+                  {
+                    auto ref_rep = orig_ov.ref_rep ();
+                    if (ref_rep->is_ptr_ref ())
+                      orig_ov = ref_rep->ref ();
+                  }
+
+                CHECK_PANIC (&orig_ov != &nested_ov);
+
+                nested_ov = new octave_value_ref_ptr (&orig_ov); // Pointer object octave_value_ref_ptr to parent stack
+              }
+            else
+              nested_ov = new octave_value_ref_vmlocal (sym, context_frame.get ());
+          }
+      }
+  }
+};
+
+void bytecode_fcn_stack_frame::accept (stack_frame_walker& sfw)
+{
+  sfw.visit_bytecode_fcn_stack_frame (*this);
+}
+
+void bytecode_script_stack_frame::accept (stack_frame_walker& sfw)
+{
+  sfw.visit_bytecode_script_stack_frame (*this);
+}
+
+void bytecode_nested_fcn_stack_frame::accept (stack_frame_walker& sfw)
+{
+  sfw.visit_bytecode_nested_fcn_stack_frame (*this);
+}
+
 void bytecode_fcn_stack_frame::display (bool) const
 {
   std::ostream& os = octave_stdout;
@@ -1809,9 +1770,28 @@
   display_scope (os, get_scope ());
 }
 
-void bytecode_fcn_stack_frame::accept (stack_frame_walker& sfw)
+void bytecode_script_stack_frame::display (bool) const
 {
-  sfw.visit_bytecode_fcn_stack_frame (*this);
+  std::ostream& os = octave_stdout;
+
+  os << "-- [bytecode_script_stack_frame] (" << this << ") --" << std::endl;
+
+  os << "fcn: " << m_fcn->name ()
+     << " (" << m_fcn->type_name () << ")" << std::endl;
+
+  display_scope (os, get_scope ());
+}
+
+void bytecode_nested_fcn_stack_frame::display (bool) const
+{
+  std::ostream& os = octave_stdout;
+
+  os << "-- [bytecode_nested_fcn_stack_frame] (" << this << ") --" << std::endl;
+
+  os << "fcn: " << m_fcn->name ()
+     << " (" << m_fcn->type_name () << ")" << std::endl;
+
+  display_scope (os, get_scope ());
 }
 
 #endif
